
/* Chrysalide - Outil d'analyse de fichiers binaires
 * access.h - prototypes pour la représentation des accès à des éléments d'entités
 *
 * Copyright (C) 2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_ACCESS_H
#define _DECOMP_EXPR_ACCESS_H


#include <glib-object.h>


#include "../expression.h"
#include "../instruction.h"



#define G_TYPE_ACCESS_EXPRESSION               g_access_expression_get_type()
#define G_ACCESS_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_access_expression_get_type(), GAccessExpression))
#define G_IS_ACCESS_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_access_expression_get_type()))
#define G_ACCESS_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ACCESS_EXPRESSION, GAccessExpressionClass))
#define G_IS_ACCESS_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ACCESS_EXPRESSION))
#define G_ACCESS_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ACCESS_EXPRESSION, GAccessExpressionClass))



/* Définition d'un accès quelconque (instance) */
typedef struct _GAccessExpression GAccessExpression;

/* Définition d'un accès quelconque (classe) */
typedef struct _GAccessExpressionClass GAccessExpressionClass;


/* Indique le type défini pour un accès quelconque. */
GType g_access_expression_get_type(void);

/* Représente l'accès à un élément d'une entité. */
GDecInstruction *g_access_expression_new(GDecExpression *, GDecExpression *);



#endif  /* _DECOMP_EXPR_ACCESS_H */
